using System;
using System.Collections;
using System.IO;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Formatters.Soap;

[Serializable]
class Customer
{
	public string name;
	public long id;
}
class Test
{
	static void Main(string[] args)
	{
		ArrayList list = new ArrayList();

		Customer cust = new Customer();
        		cust.name = "Charles Darwin";
		cust.id = 10;
		list.Add(cust);

		cust = new Customer();
		cust.name = "Isaac Newton";
		cust.id = 20;
		list.Add(cust);

		foreach (Customer x in list)
			Console.WriteLine(x.name + ": " + x.id);

		Console.WriteLine("Saving Customer List");
		FileStream s = new FileStream("cust.txt", FileMode.Create);
		IFormatter f = new SoapFormatter();
		SaveFile(s, f, list);
	
		Console.WriteLine("Restoring to New List");
		s = new FileStream("cust.txt", FileMode.Open);
		f = new SoapFormatter();
		ArrayList list2 = (ArrayList)RestoreFile(s, f);
		
		foreach (Customer y in list2)
			Console.WriteLine(y.name + ": " + y.id);
	}

	public static void SaveFile(Stream s, IFormatter f, IList l)
	{
		f.Serialize(s, l);
		s.Close();
	}

	public static IList RestoreFile(Stream s, IFormatter f)
	{
		IList l = (IList)f.Deserialize(s);
		s.Close();
		return l;
	}

}
